// Learn cc.Class:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        
    },

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    start () {

    },


    click(){
        // 以下width, height变量为局部截图的宽高
        let imageNode = cc.find("img",this.node);
        let width = imageNode.width;
        let height = imageNode.height;
 
        let node = new cc.Node();
        node.parent = imageNode;
        let camera = node.addComponent(cc.Camera);
        node.x = 0;
        node.y = 0;

        // 设置你想要的截图内容的 cullingMask
        camera.cullingMask = 0xffffffff;

        // 新建一个 RenderTexture，并且设置 camera 的 targetTexture 为新建的 RenderTexture，这样 camera 的内容将会渲染到新建的 RenderTexture 中。
        let texture = new cc.RenderTexture();
        texture.initWithSize(width, height);
        camera.targetTexture = texture;

        // 渲染一次摄像机，即更新一次内容到 RenderTexture 中
        camera.render();

        // 这样我们就能从 RenderTexture 中获取到数据了
        let data = texture.readPixels();

        // 接下来就可以对这些数据进行操作了
        let tempCanvas = document.createElement('canvas');
        let ctx = tempCanvas.getContext('2d');
        tempCanvas.width = texture.width;
        tempCanvas.height = texture.height;

        let rowBytes = width * 4;
        for (let row = 0; row < height; row++) {
            let srow = height - 1 - row;
            let imageData = ctx.createImageData(width, 1);
            let start = srow*width*4;
            for (let i = 0; i < rowBytes; i++) {
                imageData.data[i] = data[start+i];
            }

            ctx.putImageData(imageData, 0, row);
        }

        let dataURL = tempCanvas.toDataURL("image/jpeg");
        let img = document.createElement("img");
        img.src = dataURL;


        let texture1 = new cc.Texture2D();
        texture1.initWithElement(img);


        let spriteFrame = new cc.SpriteFrame();
        spriteFrame.setTexture(texture1);

        let newSp = cc.find("imgNew",this.node);
        newSp.getComponent(cc.Sprite).spriteFrame = spriteFrame;

        if (CC_WECHATGAME){
            //获取临时canvas的截图地址
            let tempFilePath = tempCanvas.toTempFilePathSync({
                x: 0,
                y: 0,
                width: width,
                height: height,
                destWidth: width,
                destHeight: height
            })
            console.log("tempFilePath",tempFilePath)

            wx.shareAppMessage({
                title: "11111" ,
                imageUrl: tempFilePath,
            })
        }
    }
    // update (dt) {},
});
